<template>
  <div id="detail">
    <info-detail
      :backColor="backColor"
      :bordColor="bordColor"
      :bordBottomColor="bordBottomColor"
      :color="color"
      :menuList="menu"
      :info="site"
      :contInfos="detailInfo"
    ></info-detail>
  </div>
</template>

<script>
import infoDetail from '@/components/detail.vue';
import { mapActions, mapState } from 'vuex';
import _ from 'lodash';
export default {
  metaInfo() {
    return {
      title: this.siteTitle ? this.siteTitle : '就业信息网',
    };
  },
  name: 'detail',
  props: {},
  components: {
    infoDetail,
  },
  data: () => ({
    backColor: '#0457c7',
    bordColor: '#cccccc',
    bordBottomColor: '#176ebb',
    color: '#333333',
    info: {
      title: '吉林省高等学校毕业生就业信息网',
      english: 'Jilin University Graduate Employment Guidance Center',
      banner: require('@/assets/banner.jpg'),
      logo: require('@/assets/logo.png'),
      copyright: '吉ICP备09006292号-1 Copyright 2019 版权所有 吉林省高等学校毕业生就业指导中心 All Rights Reserved',
    },
    contInfos: {
      title: '我省成功举办全国高校就业指导人员培训（中级）班',
      date: '2019-12-11',
      url: require('@/assets/news.jpg'),
      content: '9月16日-20日，由全国高等学校学生信息咨询与就业指导中心主办。',
    },
    menu: [], //菜单信息
    site: {}, //站点信息
    siteTitle: '',
    sideMenu: [], //侧菜单
    detailInfo: {}, //详情信息
  }),
  async created() {
    await this.toGetSite(); //获取主站信息
    await this.loadMenu(); //获取菜单信息
    this.search();
  },
  computed: {},
  methods: {
    ...mapActions(['getSite', 'getMenu', 'getColumn', 'getNews']),
    async search() {
      //1直接拿着参数发送请求
      let result = await this.getNews({ type: 'fetch', data: { id: this.$route.query.id } });
      if (`${result.errcode}` === '0') {
        this.$set(this, `detailInfo`, result.data);
      } else {
        this.$message.error(result.errmsg ? result.errmsg : 'error');
      }
    },
    //站点信息
    async toGetSite() {
      let site = sessionStorage.getItem('site');
      if (site) {
        this.$set(this, `site`, JSON.parse(site));
        this.$set(this, `siteTitle`, this.site.name);
      } else {
        let result = await this.getSite({ type: 'search' });
        if (result.errcode === 0) {
          sessionStorage.setItem('site', JSON.stringify(result.data));
          if (_.get(result.data, `custom`)) {
            let item = result.custom;
          }
          this.$set(this, `site`, result.data);
          this.$set(this, `siteTitle`, this.site.name);
        }
      }
    },
    //菜单
    async loadMenu() {
      let menu = sessionStorage.getItem('menu');
      if (menu) {
        this.$set(this, `menu`, JSON.parse(menu));
        await this.finishedMenu();
      } else this.toGetMenu();
      this.getSubMenu();
    },
    async toGetMenu() {
      let result = await this.getMenu({ type: `list` });
      if (result.errcode === 0) {
        sessionStorage.setItem('menu', JSON.stringify(result.data));
        this.$set(this, `menu`, result.data);
        this.finishedMenu();
      }
    },
    async finishedMenu() {
      let menus = JSON.parse(JSON.stringify(this.menu));
      for (const item of menus) {
        if (item.type === 'content') {
          item.path = `/detail/${item.content_id}`;
        } else if (item.type !== 'url') {
          let res = await this.completeMenu(item);
          item.children = res;
        }
      }
      this.$set(this, `menu`, menus);
    },
    async completeMenu(item) {
      let result = await this.getColumn({
        type: `list`,
        data: { parent_id: item.id },
      });
      if (result.errcode === 0) {
        let columns = result.data;
        for (const col of columns) {
          if (col.type === 'content') {
            col.path = `/detail/${col.content_id}`;
          } else if (col.type !== 'url') {
            col.path = `/newsList/menu/${col.id}?title=${col.title}`;
            if (col.parent.includes('党员')) {
              col.path = `/memberList/menu/${col.id}?title=${col.title}`;
            }
          }
        }
        return columns;
      }
    },
    //侧菜单
    getSubMenu() {
      let data;
      if (this.type === `module`) {
        data = sessionStorage.getItem(`modules`);
        this.$set(this, `sideMenu`, []);
      } else {
        let res = this.menu.filter(fil => {
          if (fil.children) {
            let res = fil.children.filter(filc => filc.id === this.id);
            return res.length > 0;
          } else return false;
        });
        this.$set(this, `sideMenu`, res.length > 0 ? res[0].children : []);
      }
    },
  },
};
</script>

<style lang="less" scoped></style>
